#!/usr/bin/env perl

use strict;
use warnings;
use utf8;
use Compiler::Lexer;
use Lingua::Ispell qw/spellcheck/;

my $filename = 'spell.pl';
open my $fh, '<', $filename or die "Cannot open $filename: $!";
my $src = do { local $/; <$fh> };
my $lexer = Compiler::Lexer->new($filename);
my $tokens = $lexer->tokenize($src);

for my $token (@$tokens) {
    if ($token->{name} eq 'LocalVar') {
        my $val = $token->{data};
        my $val_name = substr($val, 1); # シジルの削除
        if (spellcheck($val_name)) {
            print "[Maybe Typo] '$val' at $filename line $token->{line}\n";
        }
    }
}
